'use strict';

function normalizeToOne(a) {
    var max = Math.max.apply(null, a);
    return a.map(function (n) {
        return n / max;
    });
}

function spectralFlux (_a) {
    var complexSpectrum = _a.complexSpectrum, previousComplexSpectrum = _a.previousComplexSpectrum;
    if (!previousComplexSpectrum) {
        return 0;
    }
    var normalizedRealComponent = normalizeToOne(complexSpectrum.real);
    var previousNormalizedRealComponent = normalizeToOne(previousComplexSpectrum.real);
    var sf = 0;
    for (var i = 0; i < normalizedRealComponent.length; i++) {
        var x = Math.abs(normalizedRealComponent[i]) -
            Math.abs(previousNormalizedRealComponent[i]);
        sf += Math.pow(x, 2);
    }
    return Math.sqrt(sf);
}

module.exports = spectralFlux;
